/*



*/

import java.io.*;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;

public class Count_BytesMemoryMappedFile
{
   public static void main(String[] args) throws IOException, FileNotFoundException
   {
      // Memory map the first 2GB segment of the file.
    //FileChannel fc = new FileInputStream("data").getChannel();
      FileChannel fc = new RandomAccessFile("data", "r").getChannel();
      long fileSize = fc.size();
      ByteBuffer mbb1 = fc.map(FileChannel.MapMode.READ_ONLY, 0, Integer.MAX_VALUE);

      long byteCounter = 0;

      for (int i = 0; i < Integer.MAX_VALUE - 4096; i += 4096) // jump through virtual memory pages
      {
         mbb1.get(i); // touch page and cause a page fault (try commenting this out!)
         byteCounter += 4096;
      }

      // Memory map the second segment of the file.
      int restOfFile = (int)(fileSize - Integer.MAX_VALUE - 1);
      ByteBuffer mbb2 = fc.map(FileChannel.MapMode.READ_ONLY, 1L + Integer.MAX_VALUE, restOfFile);

      int i = 0;
      for (; i < restOfFile; i += 4096)
      {
         mbb2.get(i); // touch page and cause a page fault (try commenting this out!)
         byteCounter += 4096L;
      }
      byteCounter += 4096 - (i - restOfFile); // count the last partial page

      System.out.printf("%,d bytes read from file\n", byteCounter);

      System.out.println( "hasArray() ==> " + mbb1.hasArray() );
      System.out.println( "isDirect() ==> " + mbb1.isDirect() );
      System.out.println( mbb1 );
      System.out.println( mbb2 );
      long capacity1  = mbb1.capacity();
      long capacity2  = mbb2.capacity();
      System.out.printf("%,d + %,d = %,d\n", capacity1, capacity2, capacity1+capacity2);
      fc.close();
      System.out.print("Sleeping...");
      while(true){try{Thread.sleep(1000);}catch(Exception e){}}
   }
}
